<template>
  <q-page class="q-px-md q-mt-md">
    <q-card>
      <q-card-section>
        <div class="row reverse">
          <div class="col-md-auto">
            <q-input
              bg-color="grey-13"
              @keydown.enter="onSearch"
              v-model.trim="filter.username"
              placeholder="ค้นหา อย่างน้อย 3 ตัวอักษร"
              outlined
              dense
            >
              <template v-slot:prepend>
                <q-icon name="search" class="pointer" />
              </template>
              <template v-slot:append>
                <q-icon
                  v-if="filter.username !== ''"
                  name="close"
                  @click="
                    e => {
                      filter.username = '';
                      onRequest({
                        pagination: pagination,
                        ...filter
                      });
                    }
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:after>
                <q-btn color="green" @click.prevent="onSearch" icon="search"
                  >ค้นหา</q-btn
                >
              </template>
            </q-input>
          </div>
        </div>
      </q-card-section>
      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :pagination.sync="pagination"
        :loading="loading"
        :data="data"
        separator="cell"
        row-key="id"
        @request="onRequest"
      >
        <template slot="header" slot-scope="props" :props="props">
          <q-tr>
            <q-th rowspan="2" class="bg-blue-9 text-white">
              Username
            </q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">Role</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">Currency</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">Amount</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">Stake Count</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">Member</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">Agent</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">Senior</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">Company</q-th>
          </q-tr>
          <q-tr>
            <q-th
              class="bg-light-blue-5 text-white"
              v-for="(i, index) in 4"
              :key="index"
              >W/L</q-th
            >
          </q-tr>
        </template>
        <template slot="body" slot-scope="props" :props="props">
          <MemberRow :row="props.row" :key="props.row.id" />
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import MemberRow from "./member_tr";
import { SessionStorage, LocalStorage } from "quasar";

const sessionKey = "filter_report_member_";
const username = LocalStorage.getItem("username");

export default {
  name: "Report-Member",
  components: { MemberRow },
  data() {
    return {
      data: [],
      loading: false,
      filter: {
        username: ""
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0
      }
    };
  },
  async created() {
    const filter = SessionStorage.getItem(`${sessionKey}_${username}`);
    if (filter) {
      this.filter = filter;
      await this.onSearch();
    }
    if (this.filter != "") {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    }
    document.title = "Report Member";
  },
  computed: {},
  methods: {
    ...mapActions("report/v2", ["load_dashboard"]),
    async onRequest(props) {
      const { page, rowsPerPage, sortBy, descending } = props.pagination;
      const filter = props.filter;
      this.loading = true;
      const {
        data: {
          results,
          page: { resultPage, page: perPage, total }
        }
      } = await this.load_dashboard({
        page: page,
        page_limit: rowsPerPage,
        ...filter
      });
      // clear out existing data and add new
      this.data.splice(0, this.data.length, ...results);

      // don't forget to update local pagination object
      this.pagination.page = resultPage ?? 1;
      this.pagination.rowsPerPage = perPage;
      this.pagination.rowsNumber = total;
      this.pagination.sortBy = sortBy;
      this.pagination.descending = descending;
      this.loading = false;
    },
    async onSearch() {
      if (this.filter.username.length >= 3) {
        await this.onRequest({
          pagination: this.pagination,
          filter: this.filter
        });
      }
    },
    beforeRouteLeave(to, from, next) {
      // called when the route that renders this component is about to
      // be navigated away from.
      // has access to `this` component instance.
      // persist this.search in localstorage or wherever you like it to be stored
      if (to.path.startsWith("/v2/report/member/")) {
        SessionStorage.set(`${sessionKey}_${username}`, this.filter);
      }
      next();
    }
  }
};
</script>
